|  | Home · All Classes · Modules

# QXmlResultItems Class Reference
[QtXmlPatterns module]

The QXmlResultItems class iterates through the results of evaluating an XQuery in QXmlQuery. More...

### Methods

- __init__ (self)
- QXmlItem current (self)
- bool hasError (self)
- QXmlItem next (self)

## Detailed Description

The QXmlResultItems class iterates through the results of evaluating an XQuery in QXmlQuery.

QXmlResultItems presents the evaluation of an associated query as a sequence of QXmlItems. The sequence is traversed by repeatedly calling next(), which actually produces the sequence by lazy evaluation of the query.

     QXmlQuery query;
     query.setQuery("<e/>, 1, 'two'");
     QXmlResultItems result;

     if (query.isValid()) {
         query.evaluateTo(&result);
         QXmlItem item(result.next());
         while (!item.isNull()) {
             // use item
             item = result.next();
         }
         if (result.hasError())
             /* Runtime error! */;
     }

An effect of letting next() produce the sequence by lazy evaluation is that a query error can occur on any call to next(). If an error occurs, both next() and current() will return the null QXmlItem, and hasError() will return true.

QXmlResultItems can be thought of as an "iterator" that traverses the sequence of query results once, in the forward direction. Each call to next() advances the iterator to the next QXmlItem in the sequence and returns it, and current() always returns the QXmlItem that next() returned the last time it was called.

Note: When using the QXmlResultItems overload of QXmlQuery.evaluateTo() to execute a query, it is advisable to create a new instance of this class for each new set of results rather than reusing an old instance.

## Method Documentation

### QXmlResultItems.__init__ (self)

Constructs an instance of QXmlResultItems.

### QXmlItem QXmlResultItems.current (self)

Returns the current item. The current item is the last item that was produced and returned by next().

Returns a null QXmlItem if there is no associated QXmlQuery.

### bool QXmlResultItems.hasError (self)

If an error occurred during evaluation of the query, true is returned.

Returns false if query evaluation has been done.

### QXmlItem QXmlResultItems.next (self)

Returns the next result in the sequence produced by lazy evaluation of the associated query. When the returned QXmlItem is null, either the evaluation terminated normally without producing another result, or an error occurred. Call hasError() to determine whether the null item was caused by normal termination or by an error.

Returns a null QXmlItem if there is no associated QXmlQuery.